TEMPLATE = app

QT       += core gui

greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

CONFIG += static \
          c++17

RC_ICONS = Images/icon.ico

# Run as admin on windows with MSVC
#QMAKE_LFLAGS_WINDOWS += "/MANIFESTUAC:\"level='requireAdministrator' uiAccess='false'\""

TARGET = EvilRacing

include(vendor/vendor.pri)
INCLUDEPATH += "widgets" \
    "widgets/tabs"

# The following define makes your compiler emit warnings if you use
# any Qt feature that has been marked deprecated (the exact warnings
# depend on your compiler). Please consult the documentation of the
# deprecated API in order to know how to port your code away from it.
DEFINES += QT_DEPRECATED_WARNINGS \
WIN_DESKTOP

# You can also make your code fail to compile if it uses deprecated APIs.
# In order to do so, uncomment the following line.
# You can also select to disable deprecated APIs only up to a certain version of Qt.
#DEFINES += QT_DISABLE_DEPRECATED_BEFORE=0x060000    # disables all the APIs deprecated before Qt 6.0.0

SOURCES += \
    widgets/centered_cbox.cpp \
    converter.cpp \
    deviceconfig.cpp \
    firmwareupdater.cpp \
    widgets/fixedaspratiowidget.cpp \
    hiddevice.cpp \
    main.cpp \
    mainwindow.cpp \
    mainwindow_conf.cpp \
    mousewheelguard.cpp \
    reportconverter.cpp \
    stm_main.c \
    widgets/infolabel.cpp \
    widgets/sliderprogressbar.cpp \
    widgets/switchbutton.cpp \
    widgets/tabs/advancedsettings.cpp \
    widgets/tabs/buttonconfig.cpp \
    widgets/tabs/buttonphysical.cpp \
    widgets/tabs/flasher.cpp \
    widgets/themeswitcher.cpp \
    widgets/translatebutton.cpp \
    widgets/tabs/axes.cpp \
    widgets/tabs/axesconfig.cpp

HEADERS += \
    widgets/centered_cbox.h \
    common_defines.h \
    common_types.h \
    converter.h \
    deviceconfig.h \
    firmwareupdater.h \
    widgets/fixedaspratiowidget.h \
    focuswatcher.h \
    global.h \
    hidapi.h \
    hiddevice.h \
    mainwindow.h \
    mousewheelguard.h \
    reportconverter.h \
    stm_main.h \
    widgets/infolabel.h \
    widgets/sliderprogressbar.h \
    widgets/switchbutton.h \
    widgets/tabs/advancedsettings.h \
    widgets/tabs/buttonconfig.h \
    widgets/tabs/buttonphysical.h \
    widgets/tabs/flasher.h \
    widgets/themeswitcher.h \
    widgets/translatebutton.h \
    version.h \
    widgets/tabs/axes.h \
    widgets/tabs/axesconfig.h

FORMS += \
    mainwindow.ui \
    widgets/tabs/advancedsettings.ui \
    widgets/tabs/axes.ui \
    widgets/tabs/axesconfig.ui \
    widgets/tabs/buttonconfig.ui \
    widgets/tabs/buttonphysical.ui \
    widgets/tabs/flasher.ui

TRANSLATIONS += \
    languages/RaceGear_ru.ts \
    languages/RaceGear_cs_CZ.ts \
    languages/RaceGear_sv_SE.ts \
    languages/RaceGear_fi_FI.ts \
    languages/RaceGear_sk_SK.ts \
    languages/RaceGear_hu_HU.ts \
    languages/RaceGear_de_DE.ts


# Default rules for deployment.
qnx: target.path = /tmp/$${TARGET}/bin
else: unix:!android: target.path = /opt/$${TARGET}/bin
!isEmpty(target.path): INSTALLS += target

RESOURCES += \
    resources.qrc

linux {
    QMAKE_LFLAGS += -no-pie
    LIBS += -ludev
    SOURCES += \
        linux/hidapi.c
}

win32 {
    RC_FILE = winapp.rc
    LIBS += -lhid -lsetupapi
    SOURCES += \
        windows/hidapi.c
}
