#include "fixedaspratiowidget.h"
//#include <QPainter>

//FixedAspRatioWidget::FixedAspRatioWidget(QWidget *parent) : QWidget(parent)
//{

//}

//void FixedAspRatioWidget::setPixMap(const QPixmap &pixmap)
//{

//}

//double FixedAspRatioWidget::imageAspectRatio() const{
//    return (double(m_currentImage.width())) / (double(m_currentImage.height()));
//}

//QRect FixedAspRatioWidget::centeredViewport(int width, int height) const{
//    double aspectRatio = imageAspectRatio();
//    int heightFromWidth = int(width/aspectRatio);
//    int widthFromHeight = int(height*aspectRatio);

//    if (heightFromWidth<=height) {
//        return QRect(0,(height-heightFromWidth)/2, width, heightFromWidth);
//    } else {
//        return QRect((width-widthFromHeight)/2.0, 0, widthFromHeight, height);
//    }
//}

//void FixedAspRatioWidget::paintEvent(QPaintEvent *) {
//    QPainter painter(this);
//    painter.setViewport(centeredViewport(width(), height()));
//    painter.drawImage(QRect(QPoint(0,0), size()), img);
//}


AspectRatioPixmapLabel::AspectRatioPixmapLabel(QWidget *parent) :
    QLabel(parent)
{
    this->setMinimumSize(1,1);
    setScaledContents(false);
}

void AspectRatioPixmapLabel::setPixmap ( const QPixmap & p)
{
    pix = p;
    QLabel::setPixmap(scaledPixmap());
}

int AspectRatioPixmapLabel::heightForWidth( int width ) const
{
    return pix.isNull() ? this->height() : ((qreal)pix.height()*width)/pix.width();
}

QSize AspectRatioPixmapLabel::sizeHint() const
{
    int w = this->width();
    return QSize( w, heightForWidth(w) );
}

QPixmap AspectRatioPixmapLabel::scaledPixmap() const
{
    return pix.scaled(this->size(), Qt::KeepAspectRatio, Qt::SmoothTransformation);
}

void AspectRatioPixmapLabel::resizeEvent(QResizeEvent * e)
{
    Q_UNUSED(e)
    if(!pix.isNull())
        QLabel::setPixmap(scaledPixmap());
}
