#ifndef SLIDERPROGRESSBAR_H
#define SLIDERPROGRESSBAR_H

#include <QProgressBar>

class QLabel;

class SliderProgressBar : public QProgressBar
{
    Q_OBJECT
public:
    explicit SliderProgressBar(QWidget *parent = nullptr);

    void setSliderValue(int val);
    int sliderValue() const;

protected:
    void paintEvent(QPaintEvent *event) override;
    void mousePressEvent(QMouseEvent *event) override;
    void mouseReleaseEvent(QMouseEvent *event) override;
    void mouseMoveEvent(QMouseEvent *event) override;
    void wheelEvent(QWheelEvent *event) override;
    void resizeEvent(QResizeEvent *event) override;
    void leaveEvent(QEvent *event) override;

private:
    const QColor m_handleColor = QColor(1, 119, 215);
    const QColor m_handleHoverColor = QColor(1, 105, 205);//Qt::black;
    const QColor m_handleMoveColor = QColor(1, 80, 170);

    QRect m_handle;
    QColor m_currColor;
    QLabel *m_label;

    int m_value;
    bool m_drag;

    const int m_handleThick = 10;
    const int m_min = 0;
    const int m_max = 100;

    inline int pick(const QPoint &pt) const;
    int pixelPosToRangeValue(int pos) const;
    void scrollWithDegrees(QPoint numSteps);
};

#endif // SLIDERPROGRESSBAR_H
