#include "advancedsettings.h"
#include "ui_advancedsettings.h"

#include <QFileDialog>
#include <QSettings>
#include "switchbutton.h"
#include "global.h"

#include <QDebug>
AdvancedSettings::AdvancedSettings(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::AdvancedSettings)
{
    ui->setupUi(this);

    setWindowFlags(windowFlags() & ~Qt::WindowContextHelpButtonHint);
    setWindowTitle(tr("Advanced settings"));

    connect(ui->pushButton_ok, &QPushButton::clicked, this, &AdvancedSettings::accept);
    connect(ui->widget_flasher, &Flasher::startFlash, this, &AdvancedSettings::setBlockUi);

    // theme switch button
    gEnv.pAppSettings->beginGroup("WindowSettings");
    ui->widget_themeSwitcher->setChecked(gEnv.pAppSettings->value("DarkTheme", false).toBool());
    gEnv.pAppSettings->endGroup();
    connect(ui->widget_themeSwitcher, &SwitchButton::stateChanged, this, &AdvancedSettings::themeChanged);
}

AdvancedSettings::~AdvancedSettings()
{
    delete ui;
}


Flasher * AdvancedSettings::flasher() const
{
    return ui->widget_flasher;
}

void AdvancedSettings::unlockEnterFlasherMode(bool unlock)
{
    flasher()->deviceConnected(unlock);
}

void AdvancedSettings::flasherFound(bool found)
{
    flasher()->flasherFound(found);
}
bool block2 = false;
void AdvancedSettings::setBlockUi(bool block)
{
    ui->pushButton_ok->setDisabled(block);
    block2 = block;
//    if (block) {
//        setWindowFlags(windowFlags() & ~Qt::WindowCloseButtonHint);
//    } else {
//        setWindowFlags(windowFlags() | Qt::WindowCloseButtonHint);
//    }
}


void AdvancedSettings::reject()
{
   if (block2 == false)
      QDialog::reject();
}
