#ifndef AXES_H
#define AXES_H

#include <QWidget>

#include "deviceconfig.h"
#include "global.h"

//const QVector <deviceEnum_guiName_t> &axesList();

namespace Ui {
class Axes;
}

class Axes : public QWidget
{
    Q_OBJECT

public:
    explicit Axes(QWidget *parent = nullptr);
    ~Axes();

    void readFromConfig();
    void writeToConfig();

    void retranslateUi();

    void updateAxisRaw();
    void updateAxisOut();

    void setAxisNumber(int number);
    void setAxisName(const QString &name);

private slots:
    void calibrationStarted(int rawValue);
    void on_pushButton_StartCalib_clicked(bool checked);
    void on_pushButton_ResetCalib_clicked();

private:
    Ui::Axes *ui;
    bool m_calibrationStarted;
    int m_axisNumber;
    const QString m_kStartCalStr = tr("Calibrate");
    const QString m_kStopCalStr = tr("Stop && Save");
};

#endif // AXES_H
