#include "axesconfig.h"
#include "ui_axesconfig.h"

AxesConfig::AxesConfig(QWidget *parent)
    : QWidget(parent)
    , ui(new Ui::AxesConfig)
{
    ui->setupUi(this);

//    // axes spawn
//    for (int i = 0; i < CUSTOM_MAX_AXIS_NUM; i++) {
//        Axes *axis = new Axes(i, this);
//        ui->layoutV_Axes->addWidget(axis);
//        m_axesPtrList.append(axis);
//    }
    ui->widget_axisRight->setAxisName(tr("Right clutch"));
    ui->widget_axisRight->setAxisNumber(0);
    ui->widget_axisLeft->setAxisName(tr("Left clutch"));
    ui->widget_axisLeft->setAxisNumber(1);


    m_axesPtrList.append(ui->widget_axisRight);
    m_axesPtrList.append(ui->widget_axisLeft);
}

AxesConfig::~AxesConfig()
{
    delete ui;
}

void AxesConfig::updateButtonsState()
{
    ui->widget_buttons->buttonStateChanged();
}

void AxesConfig::retranslateUi()
{
    ui->retranslateUi(this);
    for (int i = 0; i < m_axesPtrList.size(); ++i) {
        m_axesPtrList[i]->retranslateUi();
    }
}

void AxesConfig::axesValueChanged()
{
    for (int i = 0; i < m_axesPtrList.size(); ++i) {
        m_axesPtrList[i]->updateAxisOut();
        m_axesPtrList[i]->updateAxisRaw();
    }
}

void AxesConfig::readFromConfig()
{
    for (int i = 0; i < m_axesPtrList.size(); i++) {
        m_axesPtrList[i]->readFromConfig();
    }
    ui->widget_buttons->readFromConfig();
}

void AxesConfig::writeToConfig()
{
    for (int i = 0; i < m_axesPtrList.size(); i++) {
        m_axesPtrList[i]->writeToConfig();
    }
    ui->widget_buttons->writeToConfig();
}
