#ifndef AXESCONFIG_H
#define AXESCONFIG_H

#include "axes.h"
#include <QWidget>

#include "deviceconfig.h"
#include "global.h"

namespace Ui {
class AxesConfig;
}

class AxesConfig : public QWidget
{
    Q_OBJECT

public:
    explicit AxesConfig(QWidget *parent = nullptr);
    ~AxesConfig();

    void readFromConfig();
    void writeToConfig();

    void retranslateUi();

    void axesValueChanged();
    void updateButtonsState();

signals:
    void axisRawValueChanged(int);
    void axisOutValueChanged(int);

private:
    Ui::AxesConfig *ui;

    QList<Axes *> m_axesPtrList;
};

#endif // AXESCONFIG_H
