#ifndef BUTTONCONFIG_H
#define BUTTONCONFIG_H

#include <QWidget>

#include "deviceconfig.h"
#include "global.h"

class QCheckBox;
class ButtonPhysical;

namespace Ui {
class ButtonConfig;
}

class ButtonConfig : public QWidget
{
    Q_OBJECT

public:
    explicit ButtonConfig(QWidget *parent = nullptr);
    ~ButtonConfig();

    void readFromConfig();
    void writeToConfig();

    void buttonStateChanged();

    void retranslateUi();

signals:

public slots:
    void setButtonsCount(int count);

private slots:

    void on_checkBox_EncLeft_toggled(bool checked);
    void on_checkBox_EncCenter_toggled(bool checked);
    void on_checkBox_EncRight_toggled(bool checked);

    void updateRotaryButtons(QCheckBox *chBox, bool checked);

private:
    Ui::ButtonConfig *ui;

    QList<QCheckBox *> m_shiftCheckBoxes;
    QList<ButtonPhysical *> m_PhysButtonPtrList;
};

#endif // BUTTONCONFIG_H
