#include "themeswitcher.h"
#include <QPalette>
#include <QApplication>
#include <QToolTip>
#include <QFile>
#include <QDebug>

void ThemeSwitcher::setWhite()
{
    qApp->setPalette(QPalette());

    QPalette pal(QColor(240, 240, 240));
    pal.setColor(QPalette::Disabled, QPalette::Button, QColor(210, 210, 210));
    pal.setColor(QPalette::Dark, QColor(216, 216, 216));     // qframe
    QToolTip::setPalette(pal);
    qApp->setPalette(pal);

    QFile f(":/styles/white.qss");
    if (!f.exists()) {
        qWarning() << "Unable to set stylesheet, file not found\n";
    } else {
        f.open(QFile::ReadOnly | QFile::Text);
        QTextStream ts(&f);
        qApp->setStyleSheet(ts.readAll());
    }
}


void ThemeSwitcher::setDark()
{
    qApp->setPalette(QPalette());

    QPalette pal;
    pal.setColor(QPalette::Window, QColor(52,54,58));//QColor(54,57,63));
    pal.setColor(QPalette::Button, QColor(52,54,58));
    pal.setColor(QPalette::Disabled, QPalette::Button, QColor(40,41,45));
    pal.setColor(QPalette::Base, QColor(47,48,52));//47,48,52//72,74,78
    pal.setColor(QPalette::Disabled, QPalette::Base, QColor(35,36,40));
    pal.setColor(QPalette::AlternateBase, QColor(66,66,66));
    pal.setColor(QPalette::ToolTipBase, QColor(75,76,77));

    pal.setColor(QPalette::Dark, QColor(66,66,66));     // qframe
    pal.setColor(QPalette::Light, QColor(66,66,66));    // qframe
    pal.setColor(QPalette::Shadow, QColor(20,20,20));

    pal.setColor(QPalette::Text, QColor(230,231,232));
    pal.setColor(QPalette::Disabled, QPalette::Text, QColor(127,127,127));
    pal.setColor(QPalette::WindowText, QColor(230,231,232));
    pal.setColor(QPalette::Disabled, QPalette::WindowText, QColor(127,127,127));
    pal.setColor(QPalette::ToolTipText, QColor(230,231,232));
    pal.setColor(QPalette::ButtonText, QColor(230,231,232));
    pal.setColor(QPalette::Disabled, QPalette::ButtonText, QColor(127,127,127));
    pal.setColor(QPalette::BrightText, Qt::red);
    pal.setColor(QPalette::Link, QColor(20,100,170));
    pal.setColor(QPalette::Highlight, QColor(20,100,170));
    pal.setColor(QPalette::Disabled, QPalette::Highlight, QColor(80,80,80));
    pal.setColor(QPalette::HighlightedText, QColor(230,231,232));
    pal.setColor(QPalette::Disabled, QPalette::HighlightedText, QColor(127,127,127));
    QToolTip::setPalette(pal);
    qApp->setPalette(pal);

    QFile f(":/styles/dark.qss");
    if (!f.exists()) {
        qWarning() << "Unable to set stylesheet, file not found\n";
    } else {
        f.open(QFile::ReadOnly | QFile::Text);
        QTextStream ts(&f);
        qApp->setStyleSheet(ts.readAll());
    }
}
