#ifndef TRANSLATEBUTTON_H
#define TRANSLATEBUTTON_H

#include <QToolButton>
#include <QLocale>

QT_BEGIN_NAMESPACE
class QAction;
class QMenu;
QT_END_NAMESPACE

class TranslateButton : public QToolButton
{
    Q_OBJECT
public:
    explicit TranslateButton(QWidget *parent = nullptr);

signals:
    void retranslated(QLocale::Language language);

public slots:
    void setLanguage(QLocale::Language language);
    QLocale::Language currentLanguage() const;

private slots:
    void translateEnglish();
    void translateRussian();
    void translateGerman();
    void translateCzech();
    void translateSwedish();
    void translateFinnish();
    void translateSlovak();
    void translateHungarian();

private:
    void createActions();
    void createMenu();

    QLocale::Language lang;

    QMenu *menu;
    QAction *actEnglish;
    QAction *actRussian;
    QAction *actGerman;
    QAction *actCzech;
    QAction *actSwedish;
    QAction *actFinnish;
    QAction *actSlovak;
    QAction *actHungarian;

};

#endif // TRANSLATEBUTTON_H
